import Image = require("flamingo/src/routes/image");
import FlamingoOperation = require("flamingo/src/model/flamingo-operation");
import Server = require("flamingo/src/model/server");
import Config = require("flamingo/config");
import Hapi = require("@hapi/hapi");
declare const S3Route_base: {
    new (...args: any[]): {
        extractInput(operation: FlamingoOperation): Promise<import("./types").S3Input>;
        extractReader({ bucket, key }: import("./types").S3Input): Promise<() => Promise<import("flamingo/src/types/ReaderResult").ReaderResult>>;
        path: string;
        method: Hapi.Util.HTTP_METHODS_PARTIAL;
        config: Config;
        parseState: boolean;
        cors: boolean;
        description: string;
        server: Server;
        handle(operation: FlamingoOperation): Promise<any>;
        hapiConfig(defaults?: any): Hapi.ServerRoute;
        buildOperation(request: Hapi.Request, reply: Hapi.ResponseToolkit): Promise<FlamingoOperation>;
        handleError(request: Hapi.Request, reply: Hapi.ResponseToolkit, error: Error, operation?: FlamingoOperation | undefined): void;
    };
} & typeof Image;
/**
 * Flamingo Image route
 * @external Image
 * @see {@link https://piobyte.github.io/flamingo/Image.html|Image}
 */
/**
 * Route that converts an image, stored on aws s3
 * @class
 * @mixes S3
 * @extends external:Image
 */
declare class S3Route extends S3Route_base {
    constructor(conf: Config, method?: Hapi.Util.HTTP_METHODS_PARTIAL, path?: string, description?: string);
}
export = S3Route;
